"use strict";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Interceptor =
/*#__PURE__*/
function () {
  function Interceptor() {
    _classCallCheck(this, Interceptor);

    this.handlers = [];
  }

  _createClass(Interceptor, [{
    key: "use",
    value: function use(onFulfilled, onRejected) {
      this.handlers.push({
        onFulfilled: onFulfilled,
        onRejected: onRejected
      });
      return this.handlers.length - 1;
    }
  }, {
    key: "remove",
    value: function remove(id) {
      if (this.handlers[id]) {
        delete this.handlers[id];
        this.handlers[id] = null;
        return true;
      }

      return false;
    }
  }, {
    key: "forEach",
    value: function forEach(callback, thisArgs) {
      this.handlers.forEach(callback, thisArgs);
    }
  }]);

  return Interceptor;
}();

module.exports = Interceptor;