"use strict";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var PromiseChain =
/*#__PURE__*/
function () {
  function PromiseChain() {
    _classCallCheck(this, PromiseChain);

    this.chains = [];
  }

  _createClass(PromiseChain, [{
    key: "add",
    value: function add(onFulfilled, onRejected) {
      this.chains.push({
        onFulfilled: onFulfilled,
        onRejected: onRejected
      });
    }
  }, {
    key: "execute",
    value: function execute(init) {
      var promise = Promise.resolve(init);
      this.chains.forEach(function (_ref) {
        var onFulfilled = _ref.onFulfilled,
            onRejected = _ref.onRejected;
        promise = promise.then(onFulfilled, onRejected);
      });
      this.chains = [];
      return promise;
    }
  }]);

  return PromiseChain;
}();

module.exports = PromiseChain;