"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deepCopy = deepCopy;

var _typeCheck = require("./typeCheck");

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function deepCopy(obj) {
  var deepObj;

  if ((0, _typeCheck.isArray)(obj)) {
    deepObj = [];
  } else if (_typeof(obj) === 'object') {
    deepObj = {};
  } else {
    return obj;
  }

  Object.keys(obj).forEach(function (key) {
    deepObj[key] = deepCopy(obj[key]);
  });
  return deepObj;
}